/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   fdf.h                                              :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/04/20 14:27:31 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/04/21 18:53:07 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef FDF_H
# define FDF_H

# include "libft/includes/libft.h"
# include "minilibx/mlx.h"
# include <mlx.h>


/*
** for mars.fdf change value with 27" needed
** UNIT		50
** XSTART	800
** YSTART	200
** WINX		1000
** WINY		600
*/

/*
** DEFAUTL VALUE 42.fdf for exemple
** UNIT		50
** XSTART	800
** YSTART	200
** WINX		1000
** WINY		600
** CTE1		0.65
** CTE2		0.65
*/

# define TITLE		"FDF jmoiroux"
# define UNIT		50
# define XSTART		800
# define YSTART		200
# define WINX		1000
# define WINY		600
# define CTE1		0.65
# define CTE2		0.65

typedef struct		s_pts
{
	int				x;
	int				y;
	int				z;
}					t_pts;

typedef struct		s_conf
{
	void			*mlx;
	void			*win;
}					t_conf;

typedef struct		s_data
{
	t_pts			***map;
	int				width;
	int				height;
	int				fd;
	char			*filepath;
	char			*line;
	int				p1x;
	int				p1y;
	int				p2x;
	int				p2y;
	t_conf			wind;

}					t_data;

int					parse(t_data *d, char *path);
int					print_error(char *str);
int					check_fileformat(t_data *d);
int					check_fileformat_2(t_data *d, int ret, char **tmptab);
int					putfile_totab(t_data *d);
int					putfile_totab_2(t_data *d, int ret, int y);
void				put_toisom(t_data *d);

int					expose_hook(t_data *d);
int					mouse_hook(int boutton, int x, int y, t_conf *wind);
int					key_hook(int keycode);
void				draw_map(t_data *d);
void				print_map(t_data *d);
void				draw_map_2(t_data *d, int o, int p);
void				draw_map_3(t_data *d, int o, int p);
void				draw_map_4(t_data *d);
void				draw_map_5(t_data *d);

#endif
